From 921f4950e1c389de651b6d7d66a2cccea40deb1b Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jan 27 2017 15:30:02 +0000
Subject: [PATCH 675/1001] Switch to a decorator system for the widget routes


It makes them much easier to declare.

---

diff --git a/hubs/app.py b/hubs/app.py
index 1990f58..07ef281 100755
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -816,6 +816,9 @@ for widget in session.query(hubs.models.Widget):
     for params in getattr(widget.module, 'ROUTES', []):
         params["rule"] = "/<hub>/<int:idx>/widget/" \
                          + params["rule"].lstrip("/")
+        if not params.get("endpoint"):
+            params["endpoint"] = params["view_func_name"]
         params["endpoint"] = "%s_%s" % (widget.plugin, params["endpoint"])
-        params["view_func"] = widget_view_decorator(params["view_func"])
+        params["view_func"] = widget_view_decorator(
+            getattr(widget.module, params.pop("view_func_name")))
         app.add_url_rule(**params)
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index 91d3931..bde7bb1 100755
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -3,6 +3,7 @@ import datetime
 import functools
 import hashlib
 import json
+import sys
 
 import dogpile.cache
 import flask
@@ -96,3 +97,13 @@ def wraps(original):
         subsequent.widget_arguments = getattr(original, 'widget_arguments', [])
         return subsequent
     return decorator
+
+
+def widget_route(**options):
+    def decorator(func):
+        options["view_func_name"] = func.__name__
+        mdict = sys.modules[func.__module__].__dict__
+        mroutes = mdict.setdefault('ROUTES', [])
+        mroutes.append(options)
+        return func
+    return decorator

